/**
 * filename:enums.js
 * desc:枚举
 * deps:jQuery
 * authors:zc
 * time:2014-08-29 0‏9:56:55
 * version:0.0.1
 * updatelog:
 * 0.0.1:the first version
 *
 */

(function(ns) {
    var seEnums = {},
        VERSION = '0.0.1',
        globalScope = ns;

    /*==========================================
    =        seTrackingModeType 跟随模式       =
    ==========================================*/
    seEnums.seTrackingModeType = {
        firstPerson: 1, //第一人称
        thirdPerson: 2, //第三人称
        free: 3 //跟随
    };
    /*-----  End of seTrackingModeType  ------*/


    /*=====================================
    =        seTrackStatus 轨迹回放状态   =
    =====================================*/
    seEnums.seTrackStatus = {
        stop: 0, //停止
        play: 1, //开始
        pause: 2 //暂停
    };
    /*-----  End of seTrackStatus  ------*/

    /*==========================================
    =        seTrackRateType 轨迹回放速度模式  =
    ==========================================*/
    seEnums.seTrackRateType = {
        fast: 0, //加速
        slow: 1, //减速
        normal: 2 //常速
    }
    /*-------  End of seTrackRateType  --------*/


    /*==========================================
    =        seMeasureType 测量类型            =
    ==========================================*/
    seEnums.seMeasureType = {
        horizontalDistance: 'HorizontalDistance', //水平距离
        height: 'Height', //垂直距离
        area: 'Area', //水平面积
        spatialArea: 'SpatialArea', //空间面积
        verticalArea: 'VerticalArea', //立面面积
        pathLength: 'PathLength', //球面距离
        lineLength: 'LineLength', //直线距离
        planeAngle: 'PlaneAngle' //平面角度
    };
    /*-----  End of seMeasureType 测量类型  ------*/

    /*==========================================
    =        seAnalysisSource  分析方式        =
    ==========================================*/
    seEnums.seAnalysisSource = {
        onlyService: 1, //仅服务端分析
        onlyLocal: 2, //仅本地
        serviceLocal: 3 //两者
    };
    /*-----  End of seAnalysisSource  ------*/

    /*=============================================
    =         seAnalysisDestination  分析目标      =
    =============================================*/
    seEnums.seAnalysisDestination = {
        dem: 1, //仅分析dem,即地形
        model: 2, //仅分析模型
        both: 3 //两者
    }
    /*-----  End of seAnalysisDestination  ------*/


    /*=====================================
    =            seProfileType            =
    =====================================*/
    seEnums.seProfileType = {
        defaultAlt: 1,
        trueAlt: 2
    };
    /*-----  End of seProfileType  ------*/









    /*======================================
    =            seParticleType  动态对象类型           =
    ======================================*/

    seEnums.seParticleType = {
        fire: 0, //火
        mist: 1, //烟
        fountain: 2, //喷泉
        nozzle: 3, //直流水枪
        SprayNozzle: 4 //喷雾水枪
    };

    /*-----  End of seParticleType  ------*/


    /*=======================================
    =            sePrimitiveType  基本图元类型          =
    =======================================*/
    seEnums.sePrimitiveType = {
        line: 'createline', //直线
        icon: 'icon', //标记
        polygon: 'createpolygon', //多边形
        curve: 'createcurve', //曲线
        circle: 'createcircle', //圆
        ellipse: 'ellipse', //椭圆
        sector: 'createsector', //扇形
        texturePolygon: 'createTexturePolygon', //矢量面贴图
        rectangle: 'createrectangle', //矩形贴图
        parallelLines: 'parallelLines', //平行线
        parallelSurface: 'parallelSurface', //平行面
        surfaceMinus: 'surfaceTosurface-2', //面面求差
        surfaceSum: 'surfaceTosurface-1', //面面求并
        surfaceMixed: 'surfaceTosurface-0', //面面求交
        sphere: 'createsphere', //
        box: 'createbox', //正立方体
        volume: 'createvolume', //多边立方体
        cylinder: 'createcylinder', //圆柱体
        cone: 'createcone', //圆锥体
        prism: 'createprism', //棱柱
        pyramid: 'createpyramid', //棱锥
        dWater: 'createdWater' //动态水面
    };
    /*-----  End of sePrimitiveType  ------*/


    /*=========================================
    =            seMiltiaryTagType  军标类型          =
    =========================================*/

    seEnums.seMiltiaryTagType = {
        sArrow: 'sArrow',
        customArrow: 'customArrow',
        tailArrow: 'tailArrow',
        customTailArrow: 'customTailArrow',
        equalSArrow: 'equalSArrow',
        doubleArrow: 'doubleArrow',
        xArrow: 'xArrow',
        assemblyArea: 'assemblyArea',
        triangleFlag: 'triangleFlag',
        rectFlag: 'rectFlag',
        curveFlag: 'curveFlag'
    };

    /*-----  End of seMiltiaryTagType  ------*/

    /*=============================================
    =            seImportModelType 导入模型类型            =
    =============================================*/

    seEnums.seImportModelType = {
        model: 'model', //模型
        tree: 'tree', //树
        match: 'match', //小品
        picture: 'picture',
        simplebuilding: 'simplebuilding',
        grid: 'grid'
    };

    /*-----  End of seImportModelType  ------*/

    /*==================================
    =            sePipeType 管线组成部分类型            =
    ==================================*/

    seEnums.sePipeType = {
        line: 0, //管线
        point: 1 //管点
    };

    /*-----  End of sePipeType  ------*/

    /*=============================================
    =            seQueryType 查询方式            =
    =============================================*/

    seEnums.seQueryType = {
        metaData: 0, //元数据类型
        spatialData: 1, //空间数据类型
        attributeData: 16, //属性数据类型
        spatial_AttributeData: 17, //空间和属性数据类型
        rangeData: 256 //值域数据类型
    };

    /*-----  End of seQueryType  ------*/

    /*======================================
    =            seGeometryType            =
    ======================================*/
    
    seEnums.seGeometryType = {
        point:0,
        line:1,
        polyline:2,
        polygon:3,
        circle:4
    };
    
    /*-----  End of seGeometryType  ------*/
    
    


    /*==========  the version  ==========*/
    seEnums.version = VERSION;



    /*======================================
    =            expose seEnums            =
    ======================================*/
    if (globalScope == undefined) {
        globalScope = window;
    }
    if (globalScope.STAMP == undefined) {
        globalScope.STAMP = {};
    }

    globalScope.STAMP.seEnums = seEnums;

    if ((typeof module) !== 'undefined' && module.exports) {
        //check for CommonJS
        module.exports = seEnums;
    } else if ((typeof define) === 'function' && define.amd) {
        //check for AMD
        define([], function() {
            return seEnums;
        });
    } else {
        globalScope.STAMP.seEnums = seEnums;
    }
    /*-----  End of expose seEnums  ------*/


})(window);
