//! fileName : markCreator.js
//! desc : 
//! deps : jquery.js, util.js
//! authors : Hurui,zhangd
//! time : 2014-10-13 15:00
//! version : 0.0.1
//! updateLog : 
(function(ns) {
    var SeMarkedCreator = {},
        VERSION = '0.0.1',
        earth,
        markedDoc = null, //标注信息XML文档对象
        MARKEDFILE_PATH = 'temp\\', //标注文件存放的路径
        pipeLineLayers = [], //管线图层数组
        markedIconList = null, //所有标注对象数组
        lineArr = [], //所有标注线数组
        datumConfigLink = null, //字段映射文件的地址
        datum = null, //空间坐标转换对象
        codeDoc = null, //管线字段映射文件对象

        //if the debugMode is true, the browser's console will throw some information
        debugMode = typeof ns.debugMode != 'undefined' ? ns.debugMode : false;

    /**
     * 检查earth是否可用
     * @param {bool} earth是否必须,若为false,则空球时仍判定成功并打印一个警告(debugMode == true时)
     * @param {string} [position] 位置,一般是函数名
     * @return {bool} earth是否可用
     */
    var _checkEarth = function(necessary, position) {
        if (position == undefined) {
            position = ''
        }

        if (earth == null) {
            if (necessary) {
                if (globalScope.debugMode) {
                    console.error('err3005:earth initialize fail,position:' + position);
                }
                return false;
            } else {
                if (globalScope.debugMode) {
                    console.warn('warn3006:earth initialize fail,position:' + position);
                }
                return true;
            }
        } else {
            return true;
        }
    };

    function _loadFieldMap() {
        //说明在之前已经进行了初始化，不用再进行第二次初始化了
        if (typeof globalScope.STAMP.sysInfo == 'undefined' || globalScope.STAMP.sysInfo == null) {
            _loadSysInfo();
        }
        if (typeof globalScope.STAMP.fieldMap == 'undefined' || globalScope.STAMP.fieldMap == null) {
            var layer = earth.LayerManager.GetLayerByGUID(globalScope.STAMP.sysInfo.project);
            if (layer) {
                var projectSetting = layer.ProjectSetting;
                var layerLink = projectSetting.PipeConfigFile; //管线配置文件
                var fieldMap = projectSetting.FieldMapFile; //字段映射配置文件
                var valueMap = projectSetting.ValueMapFile; //值域映射文件
                if (fieldMap != "") {
                    var filedPath = "";
                    if (fieldMap.indexOf("http") >= 0) {
                        filedPath = fieldMap;
                    } else {
                        filedPath = "http://" + fieldMap.substr(2).replace("/", "/sde?/") + "_sde";
                    }
                    earth.Event.OnEditDatabaseFinished = function(pRes, pFeature) {
                        if (pRes.ExcuteType == 27) {
                            var fieldMapXmlDoc = globalScope.STAMP.seUtil.loadXMLStr(pRes.AttributeName);
                            // _createFieldMapObj(fieldMapXmlDoc);
                            globalScope.STAMP.sysInfo.pipeFieldMap = fieldMapXmlDoc;
                            if (layerLink != "") {
                                var configUrl = "";
                                if (configUrl.indexOf("http") >= 0) {
                                    configUrl = layerLink;
                                } else {
                                    configUrl = "http://" + layerLink.substr(2).replace("/", "/sde?/") + "_sde";
                                }
                                globalScope.STAMP.sysInfo.pipeConfigLink = layerLink;
                                //管线配置
                                earth.Event.OnEditDatabaseFinished = function(pRes, pFeature) {
                                    if (pRes.ExcuteType == 27) {
                                        globalScope.STAMP.sysInfo.pipeConfigDoc = globalScope.STAMP.seUtil.loadXMLStr(pRes.AttributeName); //初始化管线字段映射文件
                                    }
                                }
                                earth.DatabaseManager.GetXml(configUrl);
                            }
                        }
                    }
                    earth.DatabaseManager.GetXml(filedPath);
                }
            }
        }
    };

    /**
     * 加载系统配置信息
     */
    function _loadSysInfo() {
        if (globalScope.STAMP.sysInfo == undefined) {
            globalScope.STAMP.sysInfo = {};
        }
        var rootPath = earth.Environment.RootPath + "temp\\SystemConfig";
        var configPath = rootPath + ".xml";
        var configXmlStr = earth.UserDocument.LoadXmlFile(configPath);

        //var systemDoc = globalScope.STAMP.seUtil.loadXMLStr(configXml);
        var systemJson = globalScope.STAMP.seUtil.xml2json(configXmlStr);
        if (typeof systemJson != 'undefined' && systemJson != null) {
            globalScope.STAMP.sysInfo.project = systemJson.Project;
            globalScope.STAMP.sysInfo.position = systemJson.Position;
        } else {
            alert('加载系统配置信息失败');
        }
    };

    /**
     * 将获取的字段映射文件xml内容转换为object对象
     * @param  {xml} xmldoc 字段映射xml
     */
    function _createFieldMapObj(xmldoc) {
        var fieldMapObj = {};
        fieldMapObj['lineFieldInfo'] = {};
        fieldMapObj['pointFieldInfo'] = {};
        if (xmldoc) {
            var lineFieldInfo = {};
            var pointFieldInfo = {};
            var configXML = xmldoc;
            var lineData = configXML.getElementsByTagName("LineFieldInfo")[0] ? configXML.getElementsByTagName("LineFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
            var pointData = configXML.getElementsByTagName("PointFieldInfo")[0] ? configXML.getElementsByTagName("PointFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
            if (lineData) {
                for (var i = 0; i < lineData.childNodes.length; i++) {
                    var node = lineData.childNodes[i];
                    if (!("getAttribute" in node)) {
                        continue;
                    }
                    if (node.getAttribute("FieldName") == "") {
                        continue;
                    }
                    lineFieldInfo[node.getAttribute("FieldName").toUpperCase()] = {
                        CaptionName: node.getAttribute("CaptionName"),
                        StandardName: node.getAttribute("StandardName")
                    };
                }
            }
            if (pointData) {
                for (var i = 0; i < pointData.childNodes.length; i++) {
                    var node = pointData.childNodes[i];
                    if (!("getAttribute" in node)) {
                        continue;
                    }
                    if (node.getAttribute("FieldName") == "") {
                        continue;
                    }
                    pointFieldInfo[node.getAttribute("FieldName").toUpperCase()] = {
                        CaptionName: node.getAttribute("CaptionName"),
                        StandardName: node.getAttribute("StandardName")
                    };
                }
            }
            fieldMapObj = {
                lineFieldInfo: lineFieldInfo,
                pointFieldInfo: pointFieldInfo
            };
        }
        globalScope.STAMP.sysInfo.pipeFieldMap = fieldMapObj;
    };



    SeMarkedCreator = function(options) {
        this.initialize.apply(this, arguments);
    };

    $.extend(SeMarkedCreator.prototype, {
        /**
         * 初始化
         * @param  {object} options
         * options:{
         *      earth:{object} 三维球
         * }
         * @return {void}
         */
        initialize: function(options) {

            if (typeof options == 'undefined' || options == null) {
                if (globalScope.debugMode == true) {
                    console.error('err3005, 位置: STAMP.SeMarkedCreator.initialize. 初始化参数强制需要，请参阅API文档');
                }
                return;
            }
            if (typeof options.earth == 'undefined' || options.earth == null) {
                if (globalScope.debugMode == true) {
                    console.error('err3005, 位置: STAMP.SeMarkedCreator.initialize. 参数中"earth"属性不能为空');
                    return;
                }
            }
            earth = options.earth;
            markedIconList = null;
            _loadFieldMap();
            if (typeof options.pipeData != 'undefined' && options.pipeData != null && typeof options.pipeData.pipeLineLayers != 'undefined' && options.pipeData.pipeLineLayers != null) {
                pipeLineLayers = options.pipeData.pipeLineLayers;
            }
        },
        /**
         * 功能：初始化空间坐标转换对象
         * 参数：无
         * 返回：无
         */
        initDatum: function(layerId) {
            var layerArr = layerId.split("_");
            layerId = layerArr[0];
            var layer = earth.LayerManager.GetLayerByGUID(layerId);
            var projectSetting = layer.ProjectSetting;
            var layerLink = projectSetting.SpatialRefFile;
            if ((datumConfigLink == layerLink) && (datum != null)) {
                return;
            }
            datumConfigLink = layerLink;
            var spatialUrl = "http://" + layerLink.substr(2).replace("/", "/sde?") + "_sde";
            datum = this.createDatum(spatialUrl);
        },
        /**
         * 功能：创建空间坐标转换对象
         */
        createDatum: function(spatialUrl) {
            if (spatialUrl) {
                var projectId = STAMP.sysInfo.project;
                var projLayer = earth.LayerManager.GetLayerByGUID(projectId);
                spatialUrl = projLayer.ProjectSetting.SpatialRefFile;
            }

            var dataProcess = document.getElementById("dataProcess");
            dataProcess.Load();
            var spatial = dataProcess.CoordFactory.CreateSpatialRef();
            spatialUrl = spatialUrl.replace(/\//g, "\\");
            spatial.InitFromFile(spatialUrl);
            var datum = dataProcess.CoordFactory.CreateDatum(); //earth.Factory.CreateDatum();
            datum.init(spatial);
            //datum.source.init();//修改椭球体参数
            this.sysDatum = datum;
            return datum;
        },
        /**
         * 功能：初始化管线字段映射文件对象
         * 参数：无
         * 返回：无
         */
        initCodeDoc: function(layerId) {
            if (typeof globalScope.STAMP.sysInfo == 'undefined' || globalScope.STAMP.sysInfo == null) {
                if (globalScope.debugMode) {
                    console.error('err3005, 位置: STAMP.SeMarkedCreator.initCodeDoc. 系统配置参数globalScope.STAMP.sysInfo未初始化');
                    return;
                }
            }
            datumConfigLink = globalScope.STAMP.sysInfo.pipeConfigLink; //layerLink;
            codeDoc = globalScope.STAMP.sysInfo.pipeConfigDoc; //loadXMLFile(configUrl); //初始化编码映射文件对象
        },
        /**
         * 功能：根据管线的图层ID，搜索管线信息
         * 参数：pipelineId - 管线的图层Id; filter - 搜索条件; queryType - 搜索类型; queryTableType - 搜索表类型；spatial-空间搜索对象
         * 返回：搜索结果
         */
        getPipelineInfo: function(pipelineId, filter, queryType, queryTableType, spatial, contain) {
            var pipeLayer = earth.LayerManager.GetLayerByGUID(pipelineId);
            if (pipeLayer == null) {
                return null;
            }
            var subLayer = null;
            for (var i = 0, len = pipeLayer.GetChildCount(); i < len; i++) {
                subLayer = pipeLayer.GetChildAt(i);
                if (subLayer.Name == contain) { // 使用具体的_container图层
                    break;
                }
            }
            if (subLayer == null) {
                return;
            }
            var params = subLayer.QueryParameter;
            if (params == null) {
                return null;
            }
            params.ClearRanges();
            params.ClearCompoundCondition();
            params.ClearSpatialFilter();
            params.Filter = "";
            params.Filter = filter;
            params.ClearSpatialFilter();
            if (spatial != null) {
                params.SetSpatialFilter(spatial);
            }
            params.QueryType = queryType;
            params.QueryTableType = queryTableType; //0为点表搜索；1为线表搜索
            var result = subLayer.SearchFromGISServer();
            return result;
        },
        /**
         * 功能：根据管线的图层ID和关键字，搜索管线信息
         * 参数：pipelineId - 管线的图层Id; key - 对象的关键字，即US_KEY值;
         * 返回：搜索结果
         */
        getPipeLocalInfo: function(pipelineId, key) {
            var pipeLayer = earth.LayerManager.GetLayerByGUID(pipelineId);
            if (pipeLayer == null) {
                return null;
            }
            var params = pipeLayer.LocalSearchParameter;
            if (params == null) {
                return null;
            }
            params.ReturnDataType = 0; //0 返回所有数据，1 返回xml数据，2 返回渲染数据
            params.PageRecordCount = 100;
            params.SetFilter(key, "");
            params.HasDetail = false;
            params.HasMesh = false;
            var result = pipeLayer.SearchFromLocal();
            return result;
        },
        /**
         * 功能：根据编码，获取编码对应的详细值
         * 参数：type-编码类型；codeId - 编码ID
         * 返回：编码对应的详细值
         */
        getFieldValueByCode: function(type, codeId) {
            var value = "";
            var nodes = codeDoc.getElementsByTagName(type);
            for (var i = 0; i < nodes.length; i++) {
                var node = nodes[i];
                var codeNode = node.selectSingleNode("Code");
                if (parseFloat(codeNode.text) == parseFloat(codeId)) {
                    value = node.selectSingleNode("Name").text;
                    break;
                }
            }
            return value;
        },
        getMarkedFileByTag: function(tag, b) {
            if (!b) {
                var nodes = this.getMarkedFile().getElementsByTagName("ElementMarked");
                for (var i = 0; i < nodes.length; i++) {
                    var codeNode = nodes[i];
                    if (codeNode) {
                        var nid = codeNode.getAttribute("tag");
                        var nname = codeNode.getAttribute("name");
                        if (nid == tag) {
                            alert("标注已经创建，名称是'" + nname + "'");
                            return true;
                        }
                    }
                }
            }
            return false;
        },
        /**
         * 功能：保存标注文档信息
         * 参数：markedXml-要保存的标注文档信息
         * 返回：无
         */
        saveMarkedFile: function(markedXml) {
            var savePath = earth.Environment.RootPath + MARKEDFILE_PATH + "marked";
            if (markedXml == null) {
                markedXml = markedDoc.xml;
            }
            earth.UserDocument.SaveXmlFile(savePath, markedXml);
        },

        /**
         * 功能：创建标注文档
         * 参数：无
         * 返回：新建创建的文档内容
         */
        createMarkedFile: function() {
            var id = earth.Factory.CreateGuid();
            var xmlStr = '<xml><MarkedDocument id="' + id + '" name="标注数据" checked="true" open="true"/></xml>';
            this.saveMarkedFile(xmlStr);
            return xmlStr;
        },

        /**
         * 功能：获取标注文档对象
         * 参数：无
         * 返回：标注文档对象
         */
        getMarkedFile: function() {
            var loadPath = earth.Environment.RootPath + MARKEDFILE_PATH + "marked.xml";
            var markedXml = earth.UserDocument.LoadXmlFile(loadPath);
            if ((markedXml == null) || (markedXml == "")) {
                markedXml = this.createMarkedFile();
            }
            var markedDoc = globalScope.STAMP.seUtil.loadXMLStr(markedXml);
            return markedDoc;
        },

        /**
         * 功能：初始化markedDoc对象
         * 参数：无
         * 返回：无
         */
        initMarkedDoc: function() {
            if (markedDoc == null) {
                markedDoc = this.getMarkedFile();
            }
        },

        /**
         * 功能：获取markedDoc对象
         * 参数：无
         * 返回：标注文档对象
         */
        getMarkedDoc: function() {
            if (markedDoc == null) {
                markedDoc = this.getMarkedFile();
            }
            return markedDoc;
        },

        /**
         * 功能：添加OnPickObjectEx监听事件，选取一条管线
         * 参数：queryTableType-表查询类型（1为线表查询，0为点表查询）；callback - 事件的回调函数
         * 返回：无
         */
        onMarkedCreate: function(queryTableType, callback) {
            var me = this;
            earth.Event.OnPickObjectEx = function(obj) {
                obj.Underground = true; // SEObjectFlagType.ObjectFlagUnderground
                //              earth.Paint.ClearHighlightObject();
                var parentLayerId = obj.GetParentLayerName();
                var parentLayerArr = parentLayerId.split("_");
                var searchLayerId = parentLayerArr[0];
                var us_key;
                if (queryTableType == 0) {
                    us_key = globalScope.STAMP.seUtil.getName("US_KEY", 0, true);
                } else {
                    us_key = globalScope.STAMP.seUtil.getName("US_KEY", 1, true);
                }
                var searchFilter = "(and,equal," + us_key + "," + obj.GetKey() + ")";
                var queryType = 17;
                var result = me.getPipelineInfo(searchLayerId.split("=")[1], searchFilter, queryType, queryTableType, null, parentLayerArr[1]);
                //处理搜索结果
                var resultData = null;
                if (result != null) {
                    var resultXml = result.GotoPage(0);
                    var resultDoc = globalScope.STAMP.seUtil.loadXMLStr(resultXml);
                    var resultRoot = resultDoc.documentElement;
                    if (resultRoot != null) {
                        var recordRoot = resultRoot.firstChild;
                        if ((recordRoot != null) && (recordRoot.childNodes.length > 0)) {
                            resultData = {
                                objGuid: obj.Guid,
                                layerId: parentLayerId,
                                recordRoot: recordRoot
                            };
                            obj.ShowHighLight();
                        }
                    }
                }
                callback(resultData);
                earth.Query.FinishPick();
            };
            earth.Query.PickObjectEx(24); // SEPickObjectType.PickAllObject
        },

        /**
         * 功能：根据数据节点，获取坐标信息
         * 参数：dataNode - 数据节点
         * 返回：坐标信息数组
         */
        getCoordsByNode: function(dataNode) {
            var shapeNode = dataNode.selectSingleNode("SHAPE");
            var shapeXml = shapeNode.xml;
            var coordBeginIndex = shapeXml.indexOf("<Coordinates>");
            if (coordBeginIndex == -1) {
                alert("无法获取经纬度坐标.");
                return;
            }

            coordBeginIndex = coordBeginIndex + "<Coordinates>".length;
            var coordEndIndex = shapeXml.indexOf("</Coordinates>");
            var coordStr = shapeXml.substr(coordBeginIndex, coordEndIndex - coordBeginIndex);
            var coordArr = coordStr.split(",");
            var coordList = [];
            for (var i = 0; i < coordArr.length; i = i + 3) {
                var coordPoint = {};
                coordPoint.lon = parseFloat(coordArr[i]);
                coordPoint.lat = parseFloat(coordArr[i + 1]);
                coordPoint.alt = parseFloat(coordArr[i + 2]);
                coordList.push(coordPoint);
            }
            return coordList;
        },

        /**
         * 功能：创建标注对象
         * 参数：dataParam - 创建标注对象所需的参数
         * 返回：标注对象
         */
        createElementIcon: function(dataParam) {
            var id = dataParam.id; //标注的ID编号
            if (id == null) {
                id = earth.Factory.CreateGuid();
            }
            var name = dataParam.name; //标注的名称
            var lon = dataParam.location.lon; //标注的经度坐标
            var lat = dataParam.location.lat; // 标注的纬度坐标
            var alt = dataParam.location.alt; //标注的高程
            var text = dataParam.text; //标注显示的信息
            var visibility = dataParam.visibility; //标注是否可见
            var showHandle = dataParam.showHandle;
            var handleHeight = dataParam.handleHeight;

            var markedIcon = earth.Factory.CreateElementIcon(id, name);
            markedIcon.Create(lon, lat, alt, "", "", text);
            markedIcon.Visibility = visibility;
            markedIcon.ShowHandle = showHandle;
            markedIcon.HandleHeight = handleHeight;
            markedIcon.TextFormat = 256;

            if (dataParam.name != "complexIcon") { //add by zhangd-->如果是扯旗标注，就不添加到markedIconList中，为了保证markedIconList中没有重复的扯旗标注对象
                earth.AttachObject(markedIcon);
                markedIconList.push(markedIcon); //把标注对象添加到数组中
            }

            return markedIcon;
        },

        /**
         * 功能：创建标注对象,并把标注对象添加到数组中和地球上
         * 参数：dataParam - 创建标注对象所需的参数
         * 返回：无
         */
        createMarkedIcon: function(dataParam, b) {
            var id = dataParam.id; //标注的ID编号
            if (id == null) {
                id = earth.Factory.CreateGuid();
            }
            var name = dataParam.name; //标注的名称
            var lon = dataParam.location.lon; //标注的经度坐标
            var lat = dataParam.location.lat; // 标注的纬度坐标
            var alt2 = dataParam.location.alt; //标注的高程

            if (this.getMarkedFileByTag(dataParam.tag, b)) { //检查此标注是否已经创建过
                return;
            }

            // var alt = earth.Measure.MeasureTerrainAltitude(lon, lat, false);
            // params changed after updating client at 2014-10-29
            var alt = earth.Measure.MeasureTerrainAltitude(lon, lat);
            var text = dataParam.text; //标注显示的信息
            var visibility = dataParam.visibility; //标注是否可见
            var showHandle = dataParam.showHandle;
            var handleHeight = dataParam.handleHeight;

            var markedIcon = earth.Factory.CreateElementIcon(id, name);
            markedIcon.TextFormat = 8 | 4 | 256; //markedIcon.TextFormat = 8|4|256
            markedIcon.Create(lon, lat, alt, "", "", text); //这里的text包含中文 因此牵引线高度与字母的不一致...
            markedIcon.Visibility = visibility;
            markedIcon.ShowHandle = showHandle;
            markedIcon.HandleHeight = Number(handleHeight);
            markedIcon.minVisibleRange = 0;
            markedIcon.maxVisibleRange = 100;
            earth.AttachObject(markedIcon);
            markedIconList.push(markedIcon); //把标注对象添加到数组中
            return true;
        },

        /**
         * 功能：创建标注线
         * 参数：dataParam - 创建标注线所需的参数
         * 返回：标注线对象
         */
        createElementLine: function(dataParam) {
            var id = dataParam.id; //标注的ID编号
            if (id == null) {
                id = earth.Factory.CreateGuid();
            }
            var name = dataParam.name; //标注的名称
            var visibility = dataParam.visibility; //线的可见性
            var linePoints = dataParam.linePoints; //线的点集合

            var markedLine = earth.Factory.CreateElementLine(id, name);
            markedLine.BeginUpdate();
            markedLine.SetPointArray(linePoints);
            markedLine.LineStyle.LineColor = parseInt(0xffffff00); //线颜色为黄色
            markedLine.LineStyle.LineWidth = 1; //线宽为1
            markedLine.Visibility = visibility;
            markedLine.AltitudeType = 0;
            markedLine.EndUpdate();
            return markedLine;
        },

        /**
         * 功能：创建标注节点
         * 参数：dataParam - 创建标注节点所需的参数
         * 返回：标注节点
         */
        createMarkedNode: function(dataParam) {
            var id = dataParam.id; //标注的ID编号
            var name = dataParam.name; //标注的名称
            var visibility = dataParam.visibility.toString(); //标注是否可见
            var showHandle = dataParam.showHandle.toString();
            var lon = dataParam.location.lon; //标注的经度坐标
            var lat = dataParam.location.lat; // 标注的纬度坐标
            var alt = dataParam.location.alt; //标注的高程
            var location = lon + "," + lat + "," + alt;
            var text = dataParam.text; //标注显示的信息
            text = text.replace(/\n/g, '\EN'); //将所有回车符转换为\EN保存
            var handleHeight = dataParam.handleHeight;
            var layerId = dataParam.layerId;
            var usKey = dataParam.usKey;
            var lineCoordinate = dataParam.lineCoordinate;

            var attrArr = [{
                name: "id",
                value: id
            }, {
                name: "name",
                value: name
            }, {
                name: "tag",
                value: dataParam.tag
            }, {
                name: "checked",
                value: visibility
            }];
            var markedNode = globalScope.STAMP.seUtil.createElementNode("ElementMarked", attrArr, markedDoc);
            markedNode.appendChild(globalScope.STAMP.seUtil.createElementText("ShowHandle", showHandle, markedDoc));
            markedNode.appendChild(globalScope.STAMP.seUtil.createElementText("Location", location, markedDoc));
            markedNode.appendChild(globalScope.STAMP.seUtil.createElementText("Text", text, markedDoc));
            markedNode.appendChild(globalScope.STAMP.seUtil.createElementText("HandleHeight", handleHeight, markedDoc));
            if (layerId != null) {
                markedNode.appendChild(globalScope.STAMP.seUtil.createElementText("LayerId", layerId.split("=")[1].split("_")[0], markedDoc));
            }
            if (usKey != null) {
                markedNode.appendChild(globalScope.STAMP.seUtil.createElementText("USKey", usKey, markedDoc));
            }
            if (lineCoordinate != null) {
                markedNode.appendChild(globalScope.STAMP.seUtil.createElementText("LineCoordinate", lineCoordinate, markedDoc));
            }
            return markedNode;
        },

        /**
         * 功能：创建系统目录节点
         * 参数：tagName-系统目录标签名称；name-系统目录名称
         * 返回：系统目录节点
         */
        createSystemNode: function(tagName, name) {
            var id = earth.Factory.CreateGuid();
            var attrArr = [{
                name: "id",
                value: id
            }, {
                name: "name",
                value: name
            }, {
                name: "checked",
                value: "true"
            }, {
                name: "open",
                value: "true"
            }];
            var elemNode = globalScope.STAMP.seUtil.createElementNode(tagName, attrArr, markedDoc);
            return elemNode;
        },

        /**
         * 功能：将节点elemNode作为子节点添加到指定的系统标签节点中
         * 参数：tagName-指定的系统标签名，即父目录标签名称；name-系统标签名称；elemNode-要添加的子节点
         * 返回：无
         */
        appendSystemNode: function(tagName, name, elemNode) {
            var dataRoot = markedDoc.documentElement.firstChild;
            var parentNode = dataRoot.selectSingleNode(tagName);
            if (parentNode == null) {
                parentNode = this.createSystemNode(tagName, name);
                dataRoot.appendChild(parentNode);
            }
            parentNode.setAttribute("open", "true");
            if (elemNode) {
                parentNode.appendChild(elemNode);
            }
        },
        /**
         * 功能：初始化所有标注，即创建标注对象并将对象添加到地球上
         * 参数：无
         * 返回：无
         */
        initMarkedIconList: function() {
            if (markedIconList != null) { //如果标注数组不为null，说明已经初始化过，因此不再初始化
                return;
            }

            markedIconList = []; //初始化标注数组
            var dataRoot = markedDoc.documentElement.firstChild;
            var elemMarkedList = dataRoot.getElementsByTagName("ElementMarked");
            for (var i = 0; i < elemMarkedList.length; i++) {
                var elemMarked = elemMarkedList[i];
                var dataParam = {}; //构建创建标注所需的参数对象
                dataParam.id = elemMarked.getAttribute("id");
                dataParam.name = elemMarked.getAttribute("name");
                dataParam.visibility = elemMarked.getAttribute("checked") == "true" ? true : false;

                var lineCoordNode = elemMarked.selectSingleNode("LineCoordinate");
                if (lineCoordNode != null) { //判断标注节点是否为距离标注节点，如果是距离标注节点，则创建距离标注
                    var lineCoord = lineCoordNode.text;
                    var lineCoordArr = lineCoord.split(" ");
                    var point1Arr = lineCoordArr[0].split(",");
                    var point2Arr = lineCoordArr[1].split(",");
                    var p1 = {
                        Longitude: point1Arr[0],
                        Latitude: point1Arr[1],
                        Altitude: point1Arr[2]
                    };
                    var p2 = {
                        Longitude: point2Arr[0],
                        Latitude: point2Arr[1],
                        Altitude: point2Arr[2]
                    };
                    dataParam.p1 = p1;
                    dataParam.p2 = p2;
                    if (elemMarked.parentNode.tagName == "MarkedDistance") { //判断是否为距离标注
                        this.createMarkedDistance(dataParam); //创建距离标注
                    } else if (elemMarked.parentNode.tagName == "MarkedComplex") { //判断是否为扯旗标注
                        var text = elemMarked.selectSingleNode("Text").text;
                        text = text.replace(/\EN/g, '\n'); //将所有\EN转换为回车符
                        dataParam.text = text;
                        this.createMarkedComplex(dataParam, false); //创建扯旗标注
                    } else if (elemMarked.parentNode.tagName == "ElemenAngAndLenhtMarked") {
                        this.createMarkedLine(dataParam); //创建栓点标注
                        var text = elemMarked.selectSingleNode("Text").text;
                        text = text.replace(/\EN/g, '\n'); //将所有\EN转换为回车符
                        dataParam.text = text;
                        var locationText = elemMarked.selectSingleNode("Location").text;
                        var locationArr = locationText.split(",");
                        var location = {};
                        location.lon = parseFloat(locationArr[0]);
                        location.lat = parseFloat(locationArr[1]);
                        location.alt = parseFloat(locationArr[2]);
                        dataParam.location = location;
                        dataParam.showHandle = elemMarked.selectSingleNode("ShowHandle").text == "true" ? true : false;
                        dataParam.handleHeight = elemMarked.selectSingleNode("HandleHeight").text;
                        this.createMarkedIcon(dataParam, true); //创建标注对象
                    }
                } else { //否则创建其它标注
                    var text = elemMarked.selectSingleNode("Text").text;
                    text = text.replace(/\EN/g, '\n'); //将所有\EN转换为回车符
                    dataParam.text = text;
                    var locationText = elemMarked.selectSingleNode("Location").text;
                    var locationArr = locationText.split(",");
                    var location = {};
                    location.lon = parseFloat(locationArr[0]);
                    location.lat = parseFloat(locationArr[1]);
                    location.alt = parseFloat(locationArr[2]);
                    dataParam.location = location;
                    dataParam.showHandle = elemMarked.selectSingleNode("ShowHandle").text == "true" ? true : false;
                    dataParam.handleHeight = elemMarked.selectSingleNode("HandleHeight").text;
                    this.createMarkedIcon(dataParam, true); //创建标注对象
                }
            }
        },
        /**
         * 功能：设置标注线的可见性
         * 参数：id-标注线的ID；visibility-是否可见
         * 返回：无
         */
        setLineVisibility: function(id, visibility) {
            if (id == 'undefined' || id == null) {
                return;
            }
            for (var i = 0; i < lineArr.length; i++) {
                if (id === lineArr[i].Guid) {
                    lineArr[i].visibility = visibility;
                }
            }
        },
        /**
         * 功能：设置标注对象的可见性
         * 参数：id-标注对象的ID；visibility-是否可见
         * 返回：无
         */
        setMarkedVisibility: function(id, visibility) {
            if (id == 'undefined' || id == null) {
                return;
            }
            var markedIcon = this.getMarkedIconById(id);
            var childMarkeds = markedIcon.ChildMarkeds;
            if (childMarkeds != null) { //判断标注是否为扯旗标注
                for (var customAttr in childMarkeds) {
                    childMarkeds[customAttr].visibility = visibility;
                }
            } else {
                markedIcon.visibility = visibility;
            }
        },
        /**
         * 功能：根据ID删除标注对象和标注线
         * 参数：id - 标注对象的ID编号
         * 返回：无
         */
        removeMarkById: function(id) {
            //删除标注节点，并更新文档
            var currNode = STAMP.seUtil.lookupNodeById(markedDoc, id);
            var currParNode = currNode.parentNode;
            currParNode.removeChild(currNode);

            //删除标注对象
            if (currNode.tagName == "ElementMarked") { //如果当前选中的节点为标注节点，则直接将与其相应的标注对象删除
                this.deleteMarkedIcon(currNode);
                if (currParNode.childNodes.length == 0) {
                    currParNode.parentNode.removeChild(currParNode);
                }
                for (var i = 0; i < lineArr.length; i++) {
                    if (id === lineArr[i].Guid) {
                        earth.DetachObject(lineArr[i]);
                        lineArr.splice(i, 1);
                    }
                }
            } else { //否则，获取其子节中的标注节点，并将与其相应的标注对象删除
                var markedNodes = currNode.getElementsByTagName("ElementMarked");
                for (var i = 0; i < markedNodes.length; i++) {
                    //currNode.parentNode.removeChild(currNode);
                    var markedNode = markedNodes[i];
                    for (var j = 0; j < lineArr.length; j++) {
                        var markedId = markedNode.getAttribute("id");
                        if (markedId === lineArr[j].Guid) {
                            earth.DetachObject(lineArr[j]);
                            lineArr.splice(j, 1);
                        }
                    }
                    this.deleteMarkedIcon(markedNode);
                }
                if (currParNode.childNodes.length == 0) {
                    if (currParNode.getAttribute("name") != "标注数据") {
                        currParNode.parentNode.removeChild(currParNode);
                    }
                }
            }

            this.saveMarkedFile();
        },
        /**
         * 功能：根据标注节点删除对应的标注对象
         * 参数：markedNode-标注节点
         * 返回：无
         */
        deleteMarkedIcon: function(markedNode) {
            //删除标注对象
            var markedId = markedNode.getAttribute("id");
            this.removeMarkedIconById(markedId);
        },
        /**
         * 功能：根据ID获取标注对象
         * 参数：id - 标注对象的ID编号
         * 返回：标注对象
         */
        getMarkedIconById: function(id) {
            var markedIcon = null;
            for (var i = 0; i < markedIconList.length; i++) {
                if (markedIconList[i].Guid == id) {
                    markedIcon = markedIconList[i];
                    break;
                }
            }
            return markedIcon;
        },
        /**
         * 功能：根据ID获取标注对象
         * 参数：id - 标注对象的ID编号
         * 返回：无
         */
        removeMarkedIconById: function(id) {
            for (var i = 0; i < markedIconList.length; i++) {
                if (markedIconList[i].Guid == id) {
                    var childMarkeds = markedIconList[i].ChildMarkeds;
                    if (childMarkeds != null) { //判断标注是否为距离标注和扯旗标注
                        for (var customAttr in childMarkeds) {
                            earth.DetachObject(childMarkeds[customAttr]);
                        }
                    } else {
                        var marckObj = markedIconList[i];
                        if (marckObj) {
                            earth.DetachObject(markedIconList[i]);
                        }

                    }
                    markedIconList.splice(i, 1);
                    return;
                }
            }
        },
        /**
         * 功能：球上移除所有的标注
         * 参数：无
         * 返回：无
         */
        removeAllMarkedIconAndLine: function() {
            for (var i = 0; i < markedIconList.length; i++) {
                var childMarkeds = markedIconList[i].ChildMarkeds;
                if (childMarkeds != null) { //判断是否为扯旗标注
                    for (var customAttr in childMarkeds) {
                        earth.DetachObject(childMarkeds[customAttr]);
                    }
                } else {
                    var marckObj = markedIconList[i];
                    if (marckObj) {
                        earth.DetachObject(markedIconList[i]);
                    }
                }
            }
            markedIconList = [];

            for (var i = 0; i < lineArr.length; i++) {
                earth.DetachObject(lineArr[i]);
            }
            lineArr = [];
        },

        /**
         * 功能：获取直线的长度
         * 参数：vector3s - 直线的点集合
         * 返回：直线的长度
         */
        getLineLength: function(vector3s) {
            var geoPoints = earth.Factory.CreateGeoPoints();
            var count = vector3s.Count;
            for (var i = 0; i < count; i++) {
                var vector3 = vector3s.Items(i);
                geoPoints.Add(vector3.X, vector3.Y, vector3.Z);
            }
            var length = earth.GeometryAlgorithm.CalculatePolylineLength(geoPoints);
            length = length.toFixed(3);
            return length;
        },

        /**
         * 功能：获取直线的中心点
         * 参数：vecPoint1 - 直线端点1；vecPoint2 - 直线端点2
         * 返回：直线的中心点
         */
        getCenterVector3: function(vecPoint1, vecPoint2) {
            var center = {};
            center.lon = (vecPoint1.X + vecPoint2.X) * 0.5;
            center.lat = (vecPoint1.Y + vecPoint2.Y) * 0.5;
            center.alt = (vecPoint1.Z + vecPoint2.Z) * 0.5;
            return center;
        },

        /**
         * 功能：根据直线的两个端点创建距离标注
         * 参数：dataParam - 距离标注创建参数
         * 返回：距离标注对象
         */
        createMarkedDistance: function(dataParam) {
            var p1 = dataParam.p1;
            var p2 = dataParam.p2;
            var visibility = dataParam.visibility;
            var horLinePoints = earth.Factory.CreateVector3s(); //创建水平线点集合
            var verLinePoints = earth.Factory.CreateVector3s(); //创建垂直线点集合
            var spaLinePoints = earth.Factory.CreateVector3s(); //创建直线点集合
            spaLinePoints.Add(p1.Longitude, p1.Latitude, p1.Altitude);
            spaLinePoints.Add(p2.Longitude, p2.Latitude, p2.Altitude);

            if (p1.Altitude > p2.Altitude) {
                //垂直线点集合
                verLinePoints.Add(p2.Longitude, p2.Latitude, p2.Altitude);
                verLinePoints.Add(p2.Longitude, p2.Latitude, p1.Altitude);
                //水平线点集合
                horLinePoints.Add(p2.Longitude, p2.Latitude, p1.Altitude);
                horLinePoints.Add(p1.Longitude, p1.Latitude, p1.Altitude);
            } else {
                //垂直线点集合
                verLinePoints.Add(p1.Longitude, p1.Latitude, p1.Altitude);
                verLinePoints.Add(p1.Longitude, p1.Latitude, p2.Altitude);
                //水平线点集合
                horLinePoints.Add(p1.Longitude, p1.Latitude, p2.Altitude);
                horLinePoints.Add(p2.Longitude, p2.Latitude, p2.Altitude);
            }

            var horLineParam = {
                id: null,
                name: "horLine",
                visibility: visibility,
                linePoints: horLinePoints
            };
            var horLineObj = this.createElementLine(horLineParam); //创建水平线
            earth.AttachObject(horLineObj);

            var verLineParam = {
                id: null,
                name: "verLine",
                visibility: visibility,
                linePoints: verLinePoints
            };
            var verLineObj = this.createElementLine(verLineParam); //创建垂直线
            earth.AttachObject(verLineObj);

            var spaLineParam = {
                id: null,
                name: "spaLine",
                visibility: visibility,
                linePoints: spaLinePoints
            };
            var spaLineObj = this.createElementLine(spaLineParam); //创建直线
            earth.AttachObject(spaLineObj);

            var horMarkedParam = {
                id: null,
                name: "horMarked",
                text: "水平距离: " + this.getLineLength(horLinePoints),
                location: this.getCenterVector3(horLinePoints.Items(0), horLinePoints.Items(1)),
                visibility: visibility,
                showHandle: false,
                handleHeight: 0
            };
            var horMarkedIcon = this.createElementIcon(horMarkedParam); //创建水平标注
            earth.AttachObject(horMarkedIcon);

            var verMarkedParam = {
                id: null,
                name: "verMarked",
                text: "垂直距离: " + this.getLineLength(verLinePoints),
                location: this.getCenterVector3(verLinePoints.Items(0), verLinePoints.Items(1)),
                visibility: visibility,
                showHandle: false,
                handleHeight: 0
            };
            var verMarkedIcon = this.createElementIcon(verMarkedParam); //创建垂直标注
            earth.AttachObject(verMarkedIcon);

            var center = this.getCenterVector3(spaLinePoints.Items(0), spaLinePoints.Items(1));
            var spaMarkedParam = {
                id: null,
                name: "spaMarked",
                text: "直线距离: " + this.getLineLength(spaLinePoints),
                location: center,
                visibility: visibility,
                showHandle: false,
                handleHeight: 0
            };
            var spaMarkedIcon = this.createElementIcon(spaMarkedParam); //创建直线标注
            earth.AttachObject(spaMarkedIcon);

            var id = dataParam.id;
            if (id == null) {
                id = earth.Factory.CreateGuid();
            }
            var markedDistance = {
                Guid: id,
                Name: dataParam.name,
                Location: center,
                Visibility: visibility,
                ChildMarkeds: {
                    horLine: horLineObj,
                    verLine: verLineObj,
                    spaLine: spaLineObj,
                    horMarkedIcon: horMarkedIcon,
                    verMarkedIcon: verMarkedIcon,
                    spaMarkedIcon: spaMarkedIcon
                }
            };
            markedIconList.push(markedDistance);
            return markedDistance;
        },
        /**
         * 功能：根据直线的两个端点创建扯旗标注
         * 参数：dataParam - 扯旗标注创建参数
         * 返回：扯旗标注对象
         */
        createMarkedComplex: function(dataParam, w, p1, p2, divObj, markedName, callback) {
            var p1 = dataParam.p1;
            var p2 = dataParam.p2;
            var visibility = dataParam.visibility;
            var complexPoints = earth.Factory.CreateVector3s(); //创建直线点集合
            complexPoints.Add(p1.Longitude, p1.Latitude, p1.Altitude);
            complexPoints.Add(p2.Longitude, p2.Latitude, p2.Altitude);

            var complexLineParam = {
                id: null,
                name: "complexLine",
                visibility: visibility,
                linePoints: complexPoints
            };
            var complexLineObj = this.createElementLine(complexLineParam); //创建直线
            earth.AttachObject(complexLineObj);

            var markText = dataParam.text;
            //查询与直线相交的管线
            var spatial = "," + p1.Longitude + "," + p1.Latitude + "," + p1.Altitude + ",";
            spatial = spatial + p2.Longitude + "," + p2.Latitude + "," + p2.Altitude;
            //text = this.getMarkedComplexText(spatial);
            if (markText == null) {
                textStr = "管线名称, 管径, 材质类型, 起点埋深, 终点埋深";
            } else {
                textStr = markText;
            }
            var urlList = [];
            for (var i = 0; i < pipeLineLayers.length; i++) {
                if (!datumConfigLink || !codeDoc) {
                    this.initCodeDoc(pipeLineLayers[i].id);
                }
                //这里也需要修改...这里修改为图层名
                //var pipeName = this.getFieldValueByCode("PipeCode", pipeLineLayers[i].pltype);
                var pipeName = pipeLineLayers[i].name;
                //管线搜寻
                var searchUrl = pipeLineLayers[i].server + "pipeline?rt=transect&service=" + pipeLineLayers[i].id;
                searchUrl = searchUrl + "&aparam=0" + spatial;
                urlList.push({
                    "url": searchUrl,
                    "pipeName": pipeName
                });
            }
            this.sendMarkService(urlList, markText, complexPoints, visibility, dataParam, complexLineObj, w, p1, p2, divObj, markedName, callback);
        },
        sendMarkService: function(urlList, markText, complexPoints, visibility, dataParam, complexLineObj, w, p1, p2, divObj, markedName, callback) {
            var me = this;
            var callbackFunc = null;
            if (callback != null && typeof callback != 'undefined') {
                callbackFunc = callback;
            }
            if (markText == null) { //如果text为null说明是创建扯旗标注，则要查询所有的管线获取text信息；如果text不为null说明是还原扯旗标注，则不用再进行查询
                if (urlList) {
                    var tempArr = urlList.shift();
                    earth.Event.OnEditDatabaseFinished = function(pRes, pFeature) {
                        if (pRes.ExcuteType == 27) {
                            var xmlStr = pRes.AttributeName;
                            var resultDoc = globalScope.STAMP.seUtil.loadXMLStr(xmlStr);
                            var us_size = globalScope.STAMP.seUtil.getNameNoIgnoreCase("US_SIZE", 1, true);
                            var us_pmater = globalScope.STAMP.seUtil.getNameNoIgnoreCase("US_PMATER", 1, true);
                            var us_sdeep = globalScope.STAMP.seUtil.getNameNoIgnoreCase("US_SDEEP", 1, true);
                            var us_edeep = globalScope.STAMP.seUtil.getNameNoIgnoreCase("US_EDEEP", 1, true);
                            if (resultDoc != null && resultDoc.xml != "") {
                                var dataRoot = resultDoc.documentElement.firstChild;
                                if (parseFloat(dataRoot.getAttribute("num")) > 0) {
                                    for (var k = 0; k < dataRoot.childNodes.length; k++) {
                                        var dataNode = dataRoot.childNodes[k];
                                        var diameter = parseFloat(dataNode.selectSingleNode(us_size).text);
                                        if (diameter === 0 || diameter === undefined || diameter === "") {
                                            //diameter = parseFloat(dataNode.selectSingleNode("US_PWIDTH").text) + "X" + parseFloat(dataNode.selectSingleNode("US_PHEIGHT").text);
                                        }
                                        var materialId = dataNode.selectSingleNode(us_pmater).text;
                                        //var material = this.getFieldValueByCode("Materials", materialId);
                                        var material = materialId;
                                        var startDeep = parseFloat(dataNode.selectSingleNode(us_sdeep).text);
                                        var endDeep = parseFloat(dataNode.selectSingleNode(us_edeep).text);
                                        textStr = textStr + "\n" + tempArr.pipeName + ", " + diameter + ", " + material + ", " + startDeep.toFixed(3) + ", " + endDeep.toFixed(3);
                                    }
                                }
                            }
                        }
                        if (urlList.length == 0) {
                            me.addMarkedComplex(complexPoints, visibility, dataParam, complexLineObj, w, p1, p2, divObj, markedName);
                            if (callbackFunc != null && typeof callbackFunc != 'undefined') {
                                callbackFunc();
                            }
                        }
                        if (urlList.length != 0) {
                            me.sendMarkService(urlList, markText, complexPoints, visibility, dataParam, complexLineObj, w, p1, p2, divObj, markedName, callbackFunc);
                        }
                    }
                    if (tempArr != undefined) {
                        earth.DatabaseManager.GetXml(tempArr["url"]);
                    }

                }
            }
            if (markText != null) {
                me.addMarkedComplex(complexPoints, visibility, dataParam, complexLineObj, w, p1, p2, divObj, markedName);
                if (callbackFunc != null && typeof callbackFunc != 'undefined') {
                    callbackFunc();
                }

            }
        },
        /**
         * 功能：创建并保存扯旗标注节点（服务器上）
         * 参数：complexPoints - 扯旗标注坐标点
         * 返回：扯旗标注对象
         */
        addMarkedComplex: function(complexPoints, visibility, dataParam, complexLineObj, w, p1, p2, divObj, markedName) {
            var center = {
                lon: complexPoints.Items(1).X,
                lat: complexPoints.Items(1).Y,
                alt: complexPoints.Items(1).Z
            };
            var complexIconParam = {
                id: null,
                name: "complexIcon",
                text: textStr,
                location: center,
                visibility: visibility,
                showHandle: true,
                handleHeight: 6
            };
            var complexIconObj = this.createElementIcon(complexIconParam); //创建直线标注
            earth.AttachObject(complexIconObj);

            var id = dataParam.id;
            if (id == null) {
                id = earth.Factory.CreateGuid();
            }
            var markedComplex = {
                Guid: id,
                Name: dataParam.name,
                Location: center,
                Visibility: visibility,
                ChildMarkeds: {
                    complexLine: complexLineObj,
                    complexIcon: complexIconObj
                }
            };
            markedIconList.push(markedComplex);

            if (w) { //创建扯旗是为true ，加载时为false，为了处理跨域时增加的处理变量
                //创建扯旗标注节点，准备距离标注参数
                var lineCoordinate = p1.Longitude + "," + p1.Latitude + "," + p1.Altitude + " ";
                lineCoordinate = lineCoordinate + p2.Longitude + "," + p2.Latitude + "," + p2.Altitude;
                var markedParam = {
                    id: markedComplex.Guid,
                    name: markedName,
                    tag: markedComplex.Guid,
                    text: markedComplex.ChildMarkeds.complexIcon.Text,
                    location: markedComplex.Location,
                    visibility: true,
                    showHandle: true,
                    handleHeight: 6,
                    lineCoordinate: lineCoordinate
                };
                var complexNode = this.createMarkedNode(markedParam);
                this.appendSystemNode("MarkedComplex", "扯旗标注", complexNode);
                this.saveMarkedFile();
            }
        },
        /**
         * 功能：创建栓点标注节点
         * 参数：markedNode - 栓点标注节点, v3s - 栓点标注坐标点
         * 返回：无
         */
        createAngleAndLengthMark: function(markedNode, v3s) {
            var guid = earth.Factory.CreateGUID();
            var lineObj = earth.Factory.CreateElementLine(guid, "line");
            lineObj.BeginUpdate();
            lineObj.SetPointArray(v3s);
            lineObj.visibility = true;
            var Linestyle = lineObj.LineStyle;
            Linestyle.LineWidth = 1;
            Linestyle.LineColor = parseInt(0xccff0000);
            lineObj.AltitudeType = 5;
            lineObj.EndUpdate();
            earth.AttachObject(lineObj);
            lineArr.push(lineObj);
            //计算长度和角度
            var c = this.getLineLength(v3s);
            var vector3s = earth.Factory.CreateVector3s();
            vector3s.add(v3s.Items(0).X, v3s.Items(0).Y, v3s.Items(0).Z);
            vector3s.add(v3s.Items(0).X, v3s.Items(0).Y, v3s.Items(1).Z);
            var vector3s1 = earth.Factory.CreateVector3s();
            vector3s1.add(v3s.Items(0).X, v3s.Items(0).Y, v3s.Items(1).Z);
            vector3s1.add(v3s.Items(1).X, v3s.Items(1).Y, v3s.Items(1).Z);
            var a = this.getLineLength(vector3s1);
            var b = this.getLineLength(vector3s);
            var pai = 2 * Math.asin(1);
            var angle = (180 * Math.asin(b / c) / pai).toFixed(3);
            //显示
            var lineCoordinate = v3s.Items(0).X + "," + v3s.Items(0).Y + "," + v3s.Items(0).Z + " " + v3s.Items(1).X + "," + v3s.Items(1).Y + "," + v3s.Items(1).Z;
            var dataParam = {
                id: guid,
                name: "Marked",
                tag: guid,
                text: "长度:" + c + "," + "坡度:" + angle,
                location: {
                    lon: v3s.Items(1).X,
                    lat: v3s.Items(1).Y,
                    alt: v3s.Items(1).Z
                },
                visibility: true,
                showHandle: false,
                handleHeight: 0,
                lineCoordinate: lineCoordinate
            };
            this.createElementIcon(dataParam); //调用创建icon方法
            var angleMarkedNode = this.createMarkedNode(dataParam);
            markedNode.appendChild(angleMarkedNode);
            this.appendSystemNode("MarkedAngleAndLength", "栓点标注", markedNode);
        },
        /**
         * 功能：创建标注线
         * 参数：dataParam - 标注线的参数
         * 返回：无
         */
        createMarkedLine: function(dataParam) {
            var p1 = dataParam.p1;
            var p2 = dataParam.p2;
            var visibility = dataParam.visibility;
            var complexPoints = earth.Factory.CreateVector3s(); //创建直线点集合
            complexPoints.Add(p1.Longitude, p1.Latitude, p1.Altitude);
            complexPoints.Add(p2.Longitude, p2.Latitude, p2.Altitude);
            //创建线
            var guid = earth.Factory.CreateGUID();
            var lineObj = earth.Factory.CreateElementLine(dataParam.id, "line");
            lineObj.BeginUpdate();
            lineObj.SetPointArray(complexPoints);
            lineObj.visibility = visibility;
            var Linestyle = lineObj.LineStyle;
            Linestyle.LineWidth = 1;
            Linestyle.LineColor = parseInt(0xccff0000);
            lineObj.AltitudeType = 0;
            lineObj.EndUpdate();
            earth.AttachObject(lineObj);
            lineArr.push(lineObj);
        },
        /**
         * 功能：坐标转换
         * 参数：coodObj - 转换前坐标
         * 返回：转换后的坐标
         */
        translateDatum: function(coodObj) {
            return datum.des_BLH_to_src_xy(coodObj.lon, coodObj.lat, coodObj.alt);
        },
        version: VERSION
    });

    if (typeof globalScope == 'undefined') {
        globalScope = window;
    }
    if (typeof globalScope.STAMP == 'undefined') {
        globalScope.STAMP = {};
    }
    //check for CommonJS
    if (typeof module !== 'undefined' && module.exports) {
        module.exports = SeMarkedCreator;
    } else if (typeof define === 'function' && define.amd) {
        define([], function() {
            return SeMarkedCreator;
        });
    } else {
        globalScope.STAMP.SeMarkedCreator = SeMarkedCreator;
    }

}).call(this, window);
