//! fileName : userData.js
//! desc : 控制三维球中用户添加的模型数据
//! deps : jquery.js util.js userDataFactory.js
//! authors : YanZhipeng
//! time : 2014-09-01 16:07
//! version : 0.0.1
//! updateLog : 
(function(ns) {
    /************************************
        Constants
    ************************************/
    var SeUserData = {},
        VERSION = '0.0.1',
        earth,
        globalScope = typeof ns != 'undefined' ? ns : window,
        debugMode = typeof ns.debugMode != 'undefined' ? ns.debugMode : false,
        //模型数组
        elements = [],
        //摄像机数组
        cameras = [],
        userDataFactory = {},
        userDataEditor = {},
        b=1;

    /************************************
        Internal function
    ************************************/
    /**
     * 检查当前球是否已经定义
     * @param {string} [position] 出现问题的函数路径
     * @param  {bool} [forcedNeedEarth] 是否强制需要使用球，默认为true
     * @return {bool}                 当前球是否被定义
     */
    function _checkEarth(position, forcedNeedEarth) {
        if (typeof position == 'undefined' || position == null) {
            position = '';
        }
        if (typeof forcedNeedEarth == 'undefined' || forcedNeedEarth == null || typeof forcedNeedEarth != 'boolean') {
            forcedNeedEarth = true;
        }
        var earthIsDefined = false;
        if (typeof earth != 'undefined') {
            earthIsDefined = true;
        } else {
            if (globalScope.debugMode) {
                if (forcedNeedEarth) {
                    console.error('err3005, 位置：' + position + '.  三维球没有初始化，三维球被强制需要。请确保执行了"initialize"函数');
                } else {
                    console.warn('warn3006, 位置：' + position + '.  三维球没有正常初始化, 建议执行"initialize"函数对其进行初始化');
                }
            }
        }
        return earthIsDefined;
    };

    /**
     * 从客户端xml文件中取得摄像机数据
     */
    function _fillCameras() {

    };

    /**
     * 从客户端xml文件中取得添加的二三维元素数据
     */
    function _fillElements() {

    };

    /************************************
        定义SeUserData
    ************************************/
    SeUserData = function(options) {
        this.initialize.apply(this, arguments);
    };

    /************************************
        对SeUserData进行扩展，暴露可供调用函数
    ************************************/
    $.extend(SeUserData.prototype, {
        initialize: function(options) {
            if (typeof options == 'undefined' || options == null) {
                if (globalScope.debugMode == true) {
                    console.error('err3005, 位置: STAMP.SeLayerManager.initialize. 初始化参数强制需要，请参阅API文档');
                }
                return;
            }
            if (typeof options.earth == 'undefined' || options.earth == null) {
                if (globalScope.debugMode == true) {
                    console.error('err3005, 位置: STAMP.SeLayerManager.initialize. 参数中"earth"属性不能为空');
                    return;
                }
            }
            earth = options.earth;
            userDataFactory = new globalScope.STAMP.SeUserDataFactory({earth:earth});
            userDataEditor = new globalScope.STAMP.SeUserDataEditor({earth:earth});
        },
        getElements: function() {
            return userDataFactory.getCameras();
        },
        getCameras: function() {
            return userDataFactory.getCameras();
        },
        initializeAllElements:function(){
        	userDataFactory.initializeAllElements();
        },
        createParticle:function(particleTypeEnum, point, particleOptions){
            return userDataFactory.createParticle(particleTypeEnum, point, particleOptions);
        },
        createPrimitives:function(primitiveType, geometry, options){
            return userDataFactory.createPrimitives(primitiveType, geometry, options);
        },
        createMilitaryTag:function(miltiaryTagType, geometry, options){
            return userDataFactory.createMilitaryTag(miltiaryTagType, geometry, options);
        },
        importModelData:function(importModelType, geometry, options) {
            return userDataFactory.importModelData(importModelType, geometry, options);
        },
    });

    if (typeof globalScope == 'undefined') {
        globalScope = window;
    }
    if (typeof globalScope.STAMP == 'undefined') {
        globalScope.STAMP = {};
    }
    //check for CommonJS
    if (typeof module !== 'undefined' && module.exports) {
        module.exports = SeUserData;
    } else if (typeof define === 'function' && define.amd) {
        define([], function() {
            return SeUserData;
        });
    } else {
        globalScope.STAMP.SeUserData = SeUserData;
    }

}).call(this, window);
