/**
 * filename:ttil.js
 * desc:通用工具方法
 * deps:jQuery,jquery.xml2json
 * authors:zc
 * time:2014-08-27 ‏‎17:45:27
 * version:0.0.1
 * updatelog:
 * 0.0.1:the first version
 *
 */

(function(ns) {
    var seUtil = {},
        VERSION = '0.0.1',
        globalScope = ns;

    /**
     * 根据标准名称返回显示字段名称
     * @param  {string}     standardName     标准字段名称
     * @param  {seEnums.sePipeType}         pipeType         管线类型 1 -- 管线 0 -- 管点
     * @param  {string}     returnFiledName  true返回FiledName false返回CaptionName
     * @return {string}                      显示名称
     */
    seUtil.getName = function(standardName, pipeType, returnFiledName) {
        if (standardName === "" || standardName === undefined) {
            return;
        }
        if (pipeType === "" || pipeType === undefined) {
            return;
        }
/*        var fieldData;
        if (pipeType === globalScope.STAMP.seEnums.sePipeType.line) {
            fieldData = globalScope.STAMP.sysInfo.pipeFieldMap.lineFieldInfo;
        } else if (pipeType === globalScope.STAMP.seEnums.sePipeType.point) {
            fieldData = globalScope.STAMP.sysInfo.pipeFieldMap.pointFieldInfo;
        }
        for (var i in fieldData) {
            var item = fieldData[i];
            if (item['StandardName'].toUpperCase() == standardName.toUpperCase()) {
                if (returnFiledName) {
                    return i;
                } else {
                    return item['CaptionName'];
                }
            }
        }
        return '';*/

        var configXML = globalScope.STAMP.sysInfo.pipeFieldMap;
        if(configXML == null){
            return;
        }
        var lineData;
        if (pipeType === 1 || pipeType === "1") {
            lineData = configXML.getElementsByTagName("LineFieldInfo")[0] ? configXML.getElementsByTagName("LineFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
        } else if (pipeType === 0 || pipeType === "0") {
            lineData = configXML.getElementsByTagName("PointFieldInfo")[0] ? configXML.getElementsByTagName("PointFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
        }
        if (lineData && lineData.childNodes.length) {
            for (var i = lineData.childNodes.length - 1; i >= 0; i--) {
                var item = lineData.childNodes[i];
                if (item.getAttribute("StandardName").toUpperCase() == standardName.toUpperCase()) {
                    if (returnFiledName) {
                        return item.getAttribute("FieldName").toUpperCase();
                    } else {
                        return item.getAttribute("CaptionName");
                    }
                }
            };
        }
        return "";
    };

    seUtil.getNameNoIgnoreCase = function(standardName, pipeType, returnFiledName) {
        if (standardName === "" || standardName === undefined) {
            return;
        }
        if (pipeType === "" || pipeType === undefined) {
            return;
        }
        // var fieldData;
        // if (pipeType === globalScope.STAMP.seEnums.sePipeType.line) {
        //     fieldData = globalScope.STAMP.sysInfo.pipeFieldMap.lineFieldInfo;
        // } else if (pipeType === globalScope.STAMP.seEnums.sePipeType.point) {
        //     fieldData = globalScope.STAMP.sysInfo.pipeFieldMap.pointFieldInfo;
        // }
        // for (var i in fieldData) {
        //     var item = fieldData[i];
        //     if (item['StandardName'] == standardName) {
        //         if (returnFiledName) {
        //             return i;
        //         } else {
        //             return item['CaptionName'];
        //         }
        //     }
        // }

        var configXML = globalScope.STAMP.sysInfo.pipeFieldMap;
        if(configXML == null){
            return;
        }
        var lineData;
        if (pipeType === 1 || pipeType === "1") {
            lineData = configXML.getElementsByTagName("LineFieldInfo")[0] ? configXML.getElementsByTagName("LineFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
        } else if (pipeType === 0 || pipeType === "0") {
            lineData = configXML.getElementsByTagName("PointFieldInfo")[0] ? configXML.getElementsByTagName("PointFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
        }

        if (lineData && lineData.childNodes.length) {
            for (var i = lineData.childNodes.length - 1; i >= 0; i--) {
                var item = lineData.childNodes[i];
                if (item.getAttribute("StandardName") == standardName) {
                    if (returnFiledName) {
                        return item.getAttribute("FieldName");
                    } else {
                        return item.getAttribute("CaptionName");
                    }
                }
            };
        }
        return "";
    };

    /**
     * 打开子窗口
     * @param url - 子窗口地址
     * @param params - 父窗口传给子窗口的参数
     * @param width - 子窗口宽度
     * @param height - 子窗口高度
     * @returns 子窗口传给父窗口的参数
     */
    seUtil.openDialog = function(url,params,width,height){
        var is_opera = /opera/i.test(navigator.userAgent);  
        var is_ie = (/msie/i.test(navigator.userAgent) && !is_opera);
        var is_ie_6 = (is_ie && /msie 6\.0/i.test(navigator.userAgent));
        
        var value = "";
        if(is_ie_6){
            height = height + 50;
            value = window.showModalDialog(url,params,"menubar:no;dialogWidth:"+width+"px;status:no;title:no;help:no;resizable:no;scroll:yes;location:no;toolbar:no;dialogHeight:"+height+"px");
        }else{
            value = window.showModalDialog(url,params,"menubar:no;dialogWidth:"+width+"px;status:no;title:no;help:no;resizable:no;scroll:yes;location:no;toolbar:no;dialogHeight:"+height+"px");
        }
        return value;
    }

    seUtil.loadXMLStr = function(xmlStr) {
        var xmlDoc;
        try {
            if (window.ActiveXObject || window.ActiveXObject.prototype) {
                var activeX = ['Microsoft.XMLDOM', 'MSXML5.XMLDOM', 'MSXML.XMLDOM', 'MSXML2.XMLDOM', 'MSXML2.DOMDocument'];
                for (var i = 0; i < activeX.length; i++) {
                    try {
                        xmlDoc = new ActiveXObject(activeX[i]);
                        xmlDoc.async = false;
                        break;
                    } catch (e) {
                        continue;
                    }
                }
                if (/http/ig.test(xmlStr.substring(0, 4))) {
                    xmlDoc.load(xmlStr);
                } else {
                    xmlDoc.loadXML(xmlStr);
                }
            } else if (document.implementation && document.implementation.createDocument) {
                xmlDoc = document.implementation.createDocument('', '', null);
                xmlDoc.loadXml(xmlStr);
            } else {
                xmlDoc = null;
            }
        } catch (e) {
            xmlDoc = null;
        }
        return xmlDoc;
    }

    /**
     * 通过ID查找节点
     * @param xmlData-xml字符串或xml dom对象
     * @param id-要查找的节点的ID
     * @returns 查找到的节点
     */
    seUtil.lookupNodeById = function(xmlData,id){
        if (xmlData == undefined || xmlData == null) return null;
        
        var xmlDoc = null;
        if (typeof(xmlData) == "string"){
            xmlDoc = loadXMLStr(xmlData);
        }else{
            xmlDoc = xmlData;
        }
        
        var resultNode = null;  //返回节点
        
        //判断当前元素
        var rootNode = xmlDoc.documentElement;
        
        if (rootNode!=undefined){
            for (var i=0; rootNode.attributes!=null && rootNode.attributes.length>0 && i<rootNode.attributes.length; i++){
                if (rootNode.attributes[i].name=="id" && rootNode.attributes[i].value==id){
                    resultNode = rootNode;
                    return rootNode;
                }
            }
        }else{
            rootNode = xmlDoc;
        }
        
        for (var i=0; rootNode!=null && i<rootNode.childNodes.length; i++){ 
            var node1 = rootNode.childNodes[i]; //子节点
            
            //判断当前元素
            if (node1.attributes!=null && node1.attributes.length>0){
                for (var j=0; j<node1.attributes.length; j++){
                    if (node1.attributes[j].name=="id" && node1.attributes[j].value==id){
                        resultNode = node1;
                        break;
                    }
                }
            }
            if (resultNode != null) break;
            
            //判断当前节点下的子元素
            if (node1.childNodes.length > 0){
                resultNode = this.lookupNodeById(node1, id);
                if (resultNode != null) break;
            }
        }
        
        return resultNode;
    }

    /**
     * 功能：创建带有属性的Element节点
     * 参数：tagName-标签名；attrArr-属性列表；xmlDoc-添加的dom对象
     * 返回值：Element节点
     */
    seUtil.createElementNode = function(tagName,attrArr,xmlDoc){
        var elementNode = xmlDoc.createElement(tagName);
        if(attrArr != null){
            for(var i=0; i<attrArr.length; i++){
                var customAttr = attrArr[i];
                elementNode.setAttribute(customAttr.name, customAttr.value);
            }
        }
        return elementNode;
    }

    /**
     * 功能：创建没有属性的Element节点
     * 参数：tagName-标签名；textValue-节点文字；xmlDoc-添加的dom对象
     * 返回值：Element节点
     */
    seUtil.createElementText = function(tagName,textValue,xmlDoc){
        var elementNode = xmlDoc.createElement(tagName);
        elementNode.text = textValue;
        return elementNode;
    }

    /**
     * 向服务器发送同步请求(post方式)
     * @param  {object} options
     * options:{
     * 		url:{string} 请求的url,
     * 		data:{string} 发送到服务器的数据
     * }
     * @return {object} {
     * 		say:{
     * 			statusCode:{string} 服务请求状态码,0000:成功,0001:失败,
     * 			errMsg:{string} 错误信息
     * 		}
     * 		getMe:{string} 请求的数据,若服务请求失败,则该值为空字符串
     * }
     */
    seUtil.postData = function(options) {
        if (!options) {
            return;
        }
        var url = options.url;
        if (!url) {
            return;
        }


        var response = {
            say: {
                statusCode: '0001',
                errMsg: ''
            },
            getMe: ''
        };
        $.ajax({
            url: url,
            async: false,
            cache: false,
            type: 'POST',
            dataType: 'text',
            data: options.data,
            success: function(data, textStatus, jqXHR) {
                response.say.statusCode = '0000';
                response.say.errMsg = '';
                response.getMe = data;
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                response.say.statusCode = '0001';
                response.say.errMsg = '请求服务失败';
                response.getMe = '';
            }
        });

        return response;
    }

    /**
     * 将xml格式的字符串转换为json对象
     * @param  {string} xmlStr
     * @return {objcet}
     */
    seUtil.xml2json = function(xmlStr) {
        try {
            if (typeof xmlStr == 'string') {
                xmlStr = this.text2xml(xmlStr);
            }
            return $.xml2json(xmlStr);
        } catch (e) {
            if (globalScope.debugMode) {
                console.error(e.description + ',position:STAMP.seUtil.xml2json');
            }
        }

        return;
    }

    seUtil.text2xml = function(data) {
        if (typeof data !== "string" || !data) {
            return null;
        }

        var xml, tmp;
        try {
            if (window.DOMParser) { // Standard
                tmp = new DOMParser();
                xml = tmp.parseFromString(data, "text/xml");
            } else { // IE
                xml = new ActiveXObject("Microsoft.XMLDOM");
                xml.async = "false";
                xml.loadXML(data);
            }
        } catch (e) {
            xml = undefined;
        }

        if (!xml || !xml.documentElement || xml.getElementsByTagName("parsererror").length) {
            if (globalScope.debugMode) {
                console.error('Invalid XML,position:STAMP.seUtil.text2xml');
            }
        }
        return xml;
    }

    /**
     * 获取GUID
     * @param  {object} earth
     * @return {string} guid
     */
    seUtil.createGuid = function(earth) {
        try {
            if (earth == null) {
                if (globalScope.debugMode) {
                    console.error('err3001:earth initialize fail,position:STAMP.seUtil.createGuid');
                }
                return;
            }

            return earth.Factory.CreateGUID();
        } catch (e) {
            if (globalScope.debugMode) {
                console.error(e.description + ',position:STAMP.seUtil.createGuid');
            }
        }
    }

    seUtil.invoke = function(objects, property, params) {
        try {
            if (!property) {
                return null;
            }
            if (!objects) {
                return null;
            }

            function _invoke(obj, property, params) {
                try {
                    var value = obj[property];
                    if (value) {
                        if (typeof value === 'function') {
                            return value.call(obj, params);
                        } else {
                            return value;
                        }
                    }
                } catch (e) {

                }

                return null;
            }

            var value = null;
            if ($.isArray(objects)) {
                for (var i = 0; i < objects.length; i++) {
                    value = _invoke(objects[i], property, params);
                    if (value) {
                        return value;
                    }
                }
            } else {
                value = _invoke(objects, property, params);
            }
        } catch (e) {
            if (globalScope.debugMode) {
                console.error(e.description + ',position:STAMP.seUtil.invoke');
            }
        }

        return value;
    }

    /*==========  the version  ==========*/
    seUtil.version = VERSION;


    /*=============================================
     =            expose seUtil            =
     =============================================*/
    if (globalScope == undefined) {
        globalScope = window;
    }
    if (globalScope.STAMP == undefined) {
        globalScope.STAMP = {};
    }

    globalScope.STAMP.seUtil = seUtil;

    if ((typeof module) !== 'undefined' && module.exports) {
        //check for CommonJS
        module.exports = seUtil;
    } else if ((typeof define) === 'function' && define.amd) {
        //check for AMD
        define([], function() {
            return seUtil;
        });
    } else {
        globalScope.STAMP.seUtil = seUtil;
    }
    /*-----  End of expose seUtil  ------*/


})(window);
